"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var path = require("path");
var less = require("less");
var utils_1 = require("../utils");
var less_resolver_1 = require("./less-resolver");
var external_modules_1 = require("../external-modules");
function renderLess(content, filePath, projectRootDir, pluginsOptions) {
    return __awaiter(this, void 0, void 0, function () {
        var result, _a, compilerOptions, finalCompilerOptions, nodeModulePaths, currentDir, lessResult, err_1;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    result = '';
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 4, , 5]);
                    _a = pluginsOptions.less, compilerOptions = _a === void 0 ? {} : _a;
                    finalCompilerOptions = utils_1.mergeInto({
                        filename: '',
                        relativeUrls: true,
                        ieCompat: false,
                    }, compilerOptions);
                    return [4 /*yield*/, external_modules_1.resolveNodeModulePaths(projectRootDir)];
                case 2:
                    nodeModulePaths = _b.sent();
                    currentDir = path.dirname(filePath);
                    finalCompilerOptions.filename = path.join(currentDir, path.basename(filePath));
                    finalCompilerOptions.plugins = [less_resolver_1.LessResolver({ nodeModulePaths: nodeModulePaths })];
                    return [4 /*yield*/, less.render(content, finalCompilerOptions)];
                case 3:
                    lessResult = _b.sent();
                    result = lessResult.css;
                    return [3 /*break*/, 5];
                case 4:
                    err_1 = _b.sent();
                    throw new Error("Less compiler " + err_1.message + "\n\nWhile compiling => \"" + content);
                case 5: return [2 /*return*/, result];
            }
        });
    });
}
exports.renderLess = renderLess;
