"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var path = require("path");
var less = require("less");
var utils_1 = require("../utils");
var dynamicFilePathRegEx = /^~\/?(.*\.(?:less|css|svg|tff|png|jpe?g|))$/i;
var NmpFileManager = /** @class */ (function (_super) {
    __extends(NmpFileManager, _super);
    function NmpFileManager(nodeModulePaths) {
        if (nodeModulePaths === void 0) { nodeModulePaths = []; }
        var _this = _super.call(this) || this;
        _this.nodeModulePaths = nodeModulePaths;
        return _this;
    }
    NmpFileManager.prototype.resolveFile = function (filename) {
        var filePath = filename.replace(dynamicFilePathRegEx, '$1');
        var fileFullPath = '';
        for (var _i = 0, _a = this.nodeModulePaths; _i < _a.length; _i++) {
            var currentNodePath = _a[_i];
            fileFullPath = path.resolve(currentNodePath, filePath);
            if (utils_1.isFile(fileFullPath)) {
                return {
                    contents: utils_1.readFile(fileFullPath),
                    filename: fileFullPath,
                };
            }
        }
        return {
            contents: undefined,
            filename: filename,
        };
    };
    NmpFileManager.prototype.supports = function (filename /*, currentDirectory: string, options, environment */) {
        return this.nodeModulePaths.length > 0 && dynamicFilePathRegEx.test(filename);
    };
    NmpFileManager.prototype.supportsSync = function (filename) {
        return this.nodeModulePaths.length > 0 && dynamicFilePathRegEx.test(filename);
    };
    NmpFileManager.prototype.loadFile = function (filename /* , currentDirectory: string, options, environment */) {
        return Promise.resolve(this.resolveFile(filename));
    };
    NmpFileManager.prototype.loadFileSync = function (filename) {
        return this.resolveFile(filename);
    };
    return NmpFileManager;
}(less.FileManager));
exports.NmpFileManager = NmpFileManager;
function LessResolver(_a) {
    var nodeModulePaths = _a.nodeModulePaths;
    return {
        install: function (_lessInstance, pluginManager) {
            pluginManager.addFileManager(new NmpFileManager(nodeModulePaths));
        },
        minVersion: [2, 1, 1],
    };
}
exports.LessResolver = LessResolver;
