import { RawSourceMap } from 'source-map';
import { CompilerOptions, TranspileOptions } from 'typescript';
export interface CodeWithMap {
    code: string;
    map: string | null;
}
export declare function getSourceWithMap(filePath: string): CodeWithMap | undefined;
export declare function getTranspileOptions(overwriteOptions: TranspileOptions): TranspileOptions;
export declare function transpileModule(moduleFilePath: string, options: TranspileOptions, destFilePath?: string): Promise<void>;
export declare function updateSourceMapFor({codeWithMap, newSourceMap, destFilePath}: {
    codeWithMap: CodeWithMap;
    newSourceMap: string;
    originFilePath: string;
    destFilePath: string;
    basePath: string;
}): void;
export declare function readFileSourceMap(filePath: string): RawSourceMap | null;
export declare function compileFiles(fileNames: string[], options: CompilerOptions): void;
